## look at output of diametergrow.r

#setwd("C:/")   #insert path to where data and code for functions are kept

load("spgroup.output.Rdata")     #contains output of diametergrow.r, insert spgroup name

keep <- c(burnin:g)
nk   <- length(keep)

mdiam <- dgibbs/nk
sdiam <- sqrt(d2gibbs/nk - mdiam^2)
mgrow <- ggibbs/nk
sgrow <- sqrt(g2gibbs/nk - mgrow^2)
peff  <- bpgibbs/nk
names(peff) <- plotnames
sdp   <- sqrt(bp2gibbs/nk - peff^2)
pci   <- cbind((peff-1.96*sdp),(peff+1.96*sdp))
  rownames(pci) <- plotnames
  pci[mtree == 0,] <- NA

mldiam <- ldgibbs/nk
sldiam <- sqrt(ld2gibbs/nk - mldiam^2)
mlgrow <- lggibbs/nk
slgrow <- sqrt(lg2gibbs/nk - mlgrow^2)

#priors and posteriors

nall <- sum(nti)
vp <- matrix(c(s1,s2,mus,vi1,vi2,mui,pi1,pi2,mup,w1,w2,muw,v11,v22,muv),5,3,byrow=T)
  rownames(vp) <- c('process','ind effect','plot effect','diameter','growth')

if(COVARIATES)mgibbs <- agibbs

estimate <- c(apply(cbind(mgibbs,sgibbs,tgibbs)[keep,],2,mean),peff)
std_err  <- c(apply(cbind(mgibbs,sgibbs,tgibbs)[keep,],2,sd),sdp)
p3       <- t(apply(cbind(mgibbs,sgibbs,tgibbs)[keep,],2,quantile,c(.025,.975)))
p3       <- rbind(p3,pci)
nn       <- c(rep(nall,(ncovars+2)),n,mplot,ndobs,niobs,ntt,ntp)
p3       <- cbind(nn,estimate,std_err,p3)


pvals <- cbind(prior.mu,prior.Vmu,prior.mu)
pvals <- rbind(pvals,vp)

diampars <- matrix(NA,nrow(p3),(ncol(p3)+ncol(pvals)))
diampars[,1:5] <- p3
diampars[1:nrow(pvals),6:8] <- pvals
rownames(diampars) <- names(estimate)
colnames(diampars) <- c(colnames(p3),'par1','par2','prior mean')

outfolder <- "dgr_"
outfile <- paste(outfolder,spgroup,'_diampars.csv',sep='')
  write.csv(signif(diampars,3),outfile,row.names = TRUE,quote=FALSE)  #writes diampars to file

#determine posterior means and sd's for diameter, growth, and other columns in treemat

treeindex <- cumsum(mtree)
treeindex <- cbind(c(1,(1+treeindex[1:(mplot-1)])),treeindex)
treeindex[mtree == 0,2] <- treeindex[mtree == 0,1]
if(mplot == 1)treeindex <- matrix(treeindex[1,],1,2)

meandiam <- numeric(0)  #log diameter
sddiam   <- numeric(0)
meangrow <- numeric(0)
sdgrow   <- numeric(0)
mg       <- numeric(0)
lgdiam   <- numeric(0)
lgdinc   <- numeric(0)
lgdisd   <- numeric(0)
icol     <- numeric(0)
jcol     <- numeric(0)
tcol     <- numeric(0)
ticol    <- numeric(0)
surv     <- numeric(0)
beginyr <- numeric(0)
endyr <- numeric(0)
beginyr[1:mplot] <- yrvec[1]
endyr[1:mplot] <- yrvec[length(yrvec)]
nyr[1:mplot] <- length(yrvec)

for(j in 1:mplot){
  if(mtree[j] == 0){
     meandiam <- append(meandiam,list(numeric(0)))
     sddiam   <- append(sddiam,list(numeric(0)))
     meangrow <- append(meangrow,list(numeric(0)))
     sdgrow   <- append(sdgrow,list(numeric(0)))
     next
  }
     yj <- c(beginyr[j]:endyr[j])
     wy <- which(yrvec %in% yj,arr.ind=T)
     yjvec <- yrvec[wy]
     wj <- which(ijindex[,1] == j,arr.ind=T)
     ny <- length(yjvec)
     ng <- ny - 1
     md <- matrix(mldiam[wj,wy],length(wj),ny)
     sd <- matrix(sldiam[wj,wy],length(wj),ny)
     mg <- matrix(mlgrow[wj,wy[-length(wy)]],length(wj),ng)
     sg <- matrix(slgrow[wj,wy[-length(wy)]],length(wj),ng)
     colnames(md) <- yjvec
     colnames(sd) <- yjvec
     colnames(mg) <- yjvec[-length(yjvec)]
     colnames(sg) <- yjvec[-length(yjvec)]

    #remove NA's, extra column for growth rates
     mgna     <- which(is.na(mg),arr.ind=T)
     if(length(mgna) > 0){
       meanmg   <- apply(mg,1,mean,na.rm=T)
       mg[mgna] <- meanmg[mgna[,1]]     #fills in mean incr for that tree for missing increments
     }
       mg       <- cbind(mg,mg[,(nyr[j]-1)])

     growmat <- exp(mg)
     cumgrow <- t(apply(growmat,1,cumsum))
     wna    <- which(is.na(md),arr.ind=T)
     if(length(wna) > 0)wna    <- sort(unique(wna[,1]))
     yjvec  <- c(1:nyr[j])

     for(w in wna){
       lfit    <- lm(md[w,] ~ yjvec)
       newvals <- predict.lm(lfit,newdata=data.frame(yjvec))
       md[w,is.na(md[w,])] <- newvals[is.na(md[w,])]

       check <- diff(md[w,])
       if(min(check) < 0){
         check[check < 0] <- .00001
         dnew <- cumsum(c(md[w,1],check))
         md[w,] <- dnew
       }
     }

     sdna     <- which(is.na(sd),arr.ind=T)
     sd[sdna] <- 1
     sgna     <- which(is.na(sg),arr.ind=T)
     sg[sgna] <- 1
     sg       <- cbind(sg,rep(1,nrow(sg)))

     meandiam <- append(meandiam,list(md))
     sddiam   <- append(sddiam,list(sd))
     meangrow <- append(meangrow,list(mg))
     sdgrow   <- append(sdgrow,list(sg))

     lgdiam  <- c(lgdiam,as.vector(t(md)))
     lgdinc  <- c(lgdinc,as.vector(t(mg)))
     lgdisd  <- c(lgdisd,as.vector(t(sg)))

     yb    <- match(beginyr[j],yrvec)
     ye    <- match(endyr[j],yrvec)
     tcol  <- c(tcol,rep(c(yb:ye),mtree[j]))
     jcol  <- c(jcol,rep(j,(nyr[j]*mtree[j])))
     icol  <- c(icol,rep(c(1:mtree[j]),each=(ye - yb + 1)))
     ticol <- c(ticol,rep(c(treeindex[j,1]:treeindex[j,2]),each=(ye - yb + 1)))
     surv  <- c(surv,as.vector(t(surviv[[j]])))
}

# diamchains
  par(mfrow=c(3,4))
  gr.title <- c("intercept","canopy status","DBH","altitude")
  if(COVARIATES) for(k in 1:ncol(agibbs)){plot(agibbs[,k],type='l',ylab="Diam. incr. (mm)"); title(gr.title[k])}    else {plot(mgibbs,type='l',ylab="Diam. incr. (cm)"); title("mean") }
    yax <- c("error","variance","variance","error","error") 
  for(j in c(2,4,5,1)){
    plot(sgibbs[,j],type='l',ylab=yax[j])
    title(colnames(sgibbs)[j])
  }
  plot(ad/sum(ntt),type='l',ylab="rate"); title('acceptance rate')
  aii <- ai/g
  wlo <- which(aii < .3,arr.ind=T)  #which trees have low acceptance rates?
  hist(aii,probability=T,main='acceptance by tree')

#diampost

vs <- seq(.00001,1.2,length=200)

prior.mu  <- .3      #prior mean variance for mean growth rate
prior.Vmu <- 10

par(mfrow=c(3,2))
for(j in 1:5){
  mj <- vp[j,2]/(vp[j,1] - 1)
  if(max(sgibbs[keep,j],na.rm=T) == 0)next
  dj  <- density(sgibbs[keep,j])
  xm  <- 1.5*max(dj$x)
  xl  <- .5*min(dj$x)
  vss <- seq(xl,xm,length=200)
  plot(dj$x,dj$y,type='l',lwd=2,xlim=c(xl,xm),xlab='Parameter value',ylab='Density')
  lines(vss,vss^(-2)*dgamma(1/vss,vp[j,1],vp[j,2]),col='blue',lwd=2) #include Jacobian
  title(colnames(sgibbs)[j])
}
vt <- seq(-.2,.2,length=100)
plot(vt,dnorm(vt,0,sqrt(prior.Vmu)),col='black',type='l',lwd=2,ylim=c(0,70),
  xlab='Parameter value',ylab='Density')
title('yr effects')
for(j in 1:(nt-1)){
  dj <- density(tgibbs[keep,j])
  lines(dj$x,dj$y,type='l',col=j,lwd=2)
}
legend("topright",legend=yrvec[1:(nt-1)],col=c(1:(nt-1)),lty=1,bty="n")

#diampars

#var comparison
  sdi <- apply(tgibbs,1,sd)

par(mfrow=c(2,1))
meanyr <- apply(tgibbs[keep,],2,mean)

plot(yrvec[-nt],log10(mgrow[1,]),ylim=c(-2,.5),type='l',
   xlab="Year",ylab="Diameter increment (log cm)")
  for(i in 1:nrow(mgrow)){
    lines(yrvec[-nt],log10(mgrow[i,]))
  }

dj <- density(log10(sdi))
plot(dj$x,dj$y,type='l',xlim=c(-3,0),ylim=c(0,100),
     ylab='Density',xlab="Standard deviation (log scale)")
  text(mean(log10(sdi)),(20+max(dj$y)),'yr')
  abline(h=0)

for(j in 1:5){
  if(min(sgibbs[keep,j]) == max(sgibbs[keep,j]))next
  dj <- density(log10(sqrt(sgibbs[keep,j])))
  lines(dj$x,dj$y)
  text(mean(log10(sqrt(sgibbs[keep,j]))),(20+max(dj$y)),colnames(sgibbs)[j])
}


#diamyr

par(mfrow=c(3,2))
for(j in 1:(nt-1)){
  plot(tgibbs[keep,j],type='l',ylim=c(-.4,.4))
  title(colnames(tgibbs)[j])
  abline(h=0,lty=2)
}

#diam_ind

par(mfrow=c(2,2))
for(j in 1:4){
  plot(ingibbs[keep,j],type='l',ylim=c(-.7,.7))
  title(ins[j])
  abline(h=0,lty=2)
}


#diam_fit

#diameters and growth rates

  par(mfrow=c(1,2))

  if(length(iobs) > 0){
  lo <- mgrow[iobs] - 1.96*sgrow[iobs]
  hi <- mgrow[iobs] + 1.96*sgrow[iobs]
  xx <- dincr[iobs]
  plot(xx,mgrow[iobs],xlab='observed',ylab='predicted') ; title("Diameter Increment (mm)")
  abline(-ierr,1,lty=2)
  abline(ierr,1,lty=2)
  for(i in 1:nrow(iobs)){
    lines(c(xx[i],xx[i]),c(lo[i],hi[i]))
  }
  }

  lo <- mdiam[dobs] - 1.96*sdiam[dobs]
  hi <- mdiam[dobs] + 1.96*sdiam[dobs]
  xx <- dcens[dobs]
  plot(dcens[dobs],mdiam[dobs],xlab='observed',ylab='predicted') ; title("Diameter (cm)")
  abline(0,1,lty=2)
  for(i in 1:nrow(dobs)){
    lines(c(xx[i],xx[i]),c(lo[i],hi[i]))
  }

# random individual trees
  jj <- 1

  jj <- jj + 1
  iplot <- sort(sample(c(1:n),5))
  par(mfrow=c(5,2),mar=c(2,4,2,1),cex=1,lab=c(5,3,7),font.main=1)
  letlab <- c("a","b","c","d","e")

  for(j in 1:5){
    md  <- exp(mldiam[iplot[j],])
    lsd <- exp(mldiam[iplot[j],] - 1.96*sldiam[iplot[j],])
    hsd <- exp(mldiam[iplot[j],] + 1.96*sldiam[iplot[j],])
    mg  <- exp(mlgrow[iplot[j],])
    lsg <- exp(mlgrow[iplot[j],] - 1.96*slgrow[iplot[j],])
    hsg <- exp(mlgrow[iplot[j],] + 1.96*slgrow[iplot[j],])
    y1 <- max(0,(mean(md,na.rm=T) - 3.5))
    y2 <- y1 + 7
    id <- paste(letlab[j],") ",covars[ijindex[iplot[j],2],2]*1000,", ",ijindex[iplot[j],2],sep='')
   

    plot(yrvec,md,type='l',ylim=c(y1,y2),xlab=' ',ylab=' ',bty='n',las=1,cex.lab=2)
    lines(yrvec,lsd,lty=2)
    lines(yrvec,hsd,lty=2)
    points(yrvec,dcens[iplot[j],])
    title(id,adj=0)
    if (j==3) title(ylab="Diameter (cm)")
    plot(yrvec[-nt],mg,type='l',ylim=c(0,.5),xlab=' ',ylab=' ',bty='n',las=1,cex.lab=2)
    lines(yrvec[-nt],lsg,lty=2)
    lines(yrvec[-nt],hsg,lty=2)
    points(yrvec[-nt],dincr[iplot[j],])
    if (j==3)title(ylab="Increment (cm)")
    }



